// Doc : https://kaboomjs.com

<script src="https://kaboomjs.com/lib/0.6.0/kaboom.js"></script>
<script type="module">


// initialize kaboom context
const k = kaboom({width:window.innerWidth, height:window.innerHeight});

// add a text of size 32 at position (100, 100)
k.add([
    k.text("oh hi", 32),
    k.pos(100, 100)
]);


const player = k.add([
	
	k.rect(50,50),
	k.pos(50, 50),
	k.origin("center"),
    k.body({
        // force of .jump()
        jumpForce: 1640,
        // maximum fall velocity
        maxVel: 2400,
        width:100,
        height:100,
    }),
	k.color(0,1,1),
	k.rotate(0)
]);

let angle = player.angle;
player.jumpNb = 0;

const platform = k.addRect( k.width(), 20, 
	{
		pos: k.vec2(0, k.height() - 40),
		solid: true,
	}
);


function spawnBullet(position) { 
	const bullet = k.add([
		k.rect(50, 50),
		k.pos(position),
		// k.origin("center"),
		k.color(0.5, 0.5, 1),
		k.body(),
		// strings here means a tag
		"bullet",

	]);
	bullet.angle = angle.valueOf();
	bullet.speed = 1000;
}

// body() gives obj jump() and grounded() methods
k.keyPress("space", () => {
   if (player.grounded()) {
        player.jump(500);
		player.jumpNb+=1;
   } else {
    	spawnBullet(player.pos.clone());
    }
});

k.action("bullet", (b) => {
	b.move(	Math.sin(b.angle)*b.speed,
			Math.cos(b.angle)*b.speed);
	b.speed -= 10;
	if ( b.grounded() )
		k.destroyAll("bullet");
		//k.destroy(b);
	// remove the bullet if it's out of the scene for performance
});

k.keyDown("down", () => {
   player.jump(-100);
   angle += 0.1;
   angle = angle % 360
   player.angle = angle ;
});


k.keyDown("up", () => {
	if ( player.jumpNb < 2){
		player.jumpNb+=1;
		player.jump(500);
	}
});

k.keyDown("right", () => {
   player.move(500,0);
});

k.keyDown("left", () => {
	player.move(-500,0);
});

// and a "grounded" event
player.on("grounded", () => {
    player.jumpNb = 0;
    //k.gravity(-1600);
});
// or
// k.addText("oh hi", 32, { pos: k.vec2(100, 100) });



</script>
